//
//  BankManagement.swift
//  class_MyBank
//
//  Created by yoshiyuki oshige on 2014/08/13.
//  Copyright (c) 2014年 yoshiyuki oshige. All rights reserved.
//

import Foundation

private class Bank {
    // 残高
    var zandaka:UInt = 0
    // 入金
    func inMoney(money:UInt) -> (Bool, UInt, UInt) {
        zandaka += money
        return (true,money,zandaka)
    }
    // 出金
    func outMoney(money:UInt) -> (Bool, UInt, UInt) {
        if zandaka >= money {
            zandaka -= money
            return (true, money, zandaka)
        } else {
            //残高不足
            return (false, money, zandaka)
        }
    }
}

internal class BankManager {
    // プライベート
    private var myBank:Bank
    // ポイント（リードオンリー）
    private(set) var point:Int = 0
    // 残高（リードオンリー）
    var zandaka:UInt {
        get{
            return myBank.zandaka
        }
    }
    // イニシャライザ
    init (){
        myBank = Bank()
    }
    // 入金
    func nyukin(money:UInt) -> (Bool, UInt, UInt) {
        point += 10
        let result = myBank.inMoney(money)
        return result
    }
    // 出金
    func syukkin(money:UInt) -> (Bool, UInt, UInt) {
        let result = myBank.outMoney(money)
        return result
    }
}