//
//  ViewController.swift
//  struct_subscript
//
//  Created by yoshiyuki oshige on 2014/08/21.
//  Copyright (c) 2014年 yoshiyuki oshige. All rights reserved.
//

import UIKit


struct Stock {
    var name:String
    var data:[String:Int] = [:]
    //イニシャライザ
    init(name:String){
        self.name = name
    }
    //サブクリプト
    subscript(color:String, size:Double) -> Int {
        //値の取り出し
        get {
            let key = color + size.description
            if let value = data[key] {
                return value
            } else {
                return 0
            }
        }
        //値の設定
        set {
            let key = color + size.description
            data[key] = newValue //新しい値を設定する
        }
    }
}

class ViewController: UIViewController {
                            
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //addixの在庫
        var addixStock = Stock(name: "addix")
        //在庫設定
        addixStock["green", 24.5] = 3
        addixStock["green", 25.0] = 5
        //在庫の更新
        addixStock["green", 25.0] += 1
        addixStock["red", 26.0] = 2
        //在庫確認
        println(addixStock["green", 24.5])
        println(addixStock["green", 25.0])
        println(addixStock["green", 26.0])
        println(addixStock["red", 26.0])
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }


}

